

int get_args(struct svalue *s, INT32 num_args, char *fmt, ...)
{
  int ret=0;
  va_list ptr;

  va_start(ptr, fmt);

  while(*ftm)
  {
    if(*fmt != '%')
      fatal("Error in format for get_args.\n");

    if(ret == num_args) goto no_more;

    switch(*++fmt)
    {
    case 'd':
      if(s->type != T_INT) goto no_more;
      *va_arg(ap, int *)=s->u.integer;
      break;
    case 'i':
      if(s->type != T_INT) goto no_more;
      *va_arg(ap, INT32 *)=s->u.integer; break;
    case 's':
      if(s->type != T_STRING) goto no_more;
      *va_arg(ap, char **)=sp->u.string->str;
      break;
    case 'S':
      if(s->type != T_STRING) goto no_more;
      *va_arg(ap, struct pike_string **)=sp->u.string;
      break;
    case 'a':
      if(s->type != T_ARRAY) goto no_more;
      *va_arg(ap, struct array **)=sp->u.array;
      break;
    case 'f':
      if(s->type != T_ARRAY) goto no_more;
      *va_arg(ap, float *)=sp->u.float_number;
      break;
    case 'm':
      if(s->type != T_MAPPING) goto no_more;
      *va_arg(ap, struct mapping **)=sp->u.mapping;
      break;
    case 'M':
      if(s->type != T_MULTISET) goto no_more;
      *va_arg(ap, struct multiset **)=sp->u.multiset;
      break;
    case 'F':
      if(s->type != T_MULTISET) goto no_more;
      *va_arg(ap, struct multiset **)=sp->u.multiset;
      break;
    case 'p':
      if(s->type != T_PROGRAM) goto no_more;
      *va_arg(ap, struct multiset **)=sp->u.program;
      break;
    default:
      fatal("Unknown format character in get_args.\n");
    }
    ret++;
  }
no_more:
  va_end(ptr);
  return ret;
}
